/*
 * MinGW32 system file
 * based on nix.c and dos.c
 * req's SDL
 * -Dave Kiddell
 */

#include "rc.h"
#include "fb.h"
#include "pcm.h"
#include "regs.h"
#include "defs.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <signal.h>
#include <time.h>
//#include <SDL/SDL.h>



struct fb fb;
struct pcm pcm;

byte static_fb[160*144*3*4];

rcvar_t joy_exports[] =
{
	RCV_END
};


rcvar_t kb_exports[] =
{
	RCV_END
};

rcvar_t vid_exports[] =
{
	RCV_END
};

/*
void ev_poll()
{
}
*/

void *sys_timer()
{
}

int sys_elapsed(int *cl)
{
}

void sys_sleep(int us)
{
}

void sys_sanitize(char *s)
{
	int i;
	for (i = 0; s[i]; i++)
		if (s[i] == '\\') s[i] = '/';
}

void sys_initpath(char *exe)
{
	char *buf, *home, *p;

	home = strdup(exe);
	sys_sanitize(home);
	p = strrchr(home, '/');
	if (p) *p = 0;
	else
	{
		/* FIXME dbk: this isnt working */
//		rc_setvar("rcpath",1, ".");
//		rc_setvar("savedir",1, ".");
//		return;
	}
	buf = malloc(strlen(home) + 8);
//	sprintf(buf, ".;%s/", home);
	sprintf(buf, "%s/", home);
	rc_setvar("rcpath", 1, &buf);
//	sprintf(buf, ".", home);
	sprintf(buf, "%s/save/", home);
	rc_setvar("savedir", 1, &buf);
	free(buf);
}

void sys_checkdir(char *path, int wr)
{
}


void keyboard_init()
{
	static int first = 0;

	if(!first)
//		InitDirectInput(GUI.hwnd);
	first = 1;
}

void keyboard_chain(int i)
{
}

void keyboard_close()
{
}

void keyboard_buffer()
{
}

void keyboard_buffer_pos()
{
}


void vid_preinit()
{
	/* do nothing; only needed on systems where we must drop perms */
}

static int GetShiftCount(int mask)
{
	int i;

	if (mask == 0)
		return 0;
	for (i = 0; i < 32; i++) {
		mask >>= 1;
		if (mask == 0)
			return i+1;
	}

	return 0;
}

void vid_set_ptr(byte *ptr)
{
	fb.ptr = ptr;
}

void vid_set_pelsize(int pelsize)
{
	fb.pelsize = pelsize;
}

void vid_set_pos(int posx, int posy, int width, int height, int pitch)
{
	fb.w = 160;
	fb.h = 144;
	fb.pitch = pitch;
}

void vid_init()
{
	keyboard_init();
//		keyboard_chain(0);

	if(fb.pelsize == 3)
	{
		fb.indexed = 0;
		fb.cc[0].r = fb.cc[1].r = fb.cc[2].r = 0;
		fb.cc[0].l = 16;
		fb.cc[1].l = 8;
		fb.cc[2].l = 0;
	}else{
		fb.indexed = 1;
		fb.cc[0].r = fb.cc[1].r = fb.cc[2].r = 8;
		fb.cc[0].l = fb.cc[1].l = fb.cc[2].l = 0;
	}

	fb.w = 160;
	fb.h = 144;
	fb.pitch = fb.w * fb.pelsize;
//	fb.pitch = 640*3;
//	fb.ptr = static_fb;

	fb.enabled = 1;
	fb.dirty = 0;
}


void vid_close()
{
	fb.enabled = 0;
	keyboard_close();
}

void vid_settitle(char *title)
{
}


void vid_setpal(int i, int r, int g, int b)
{
}

void vid_begin()
{
}

byte *vid_get_gbscreen()
{
	return fb.ptr;	
}

void vid_end()
{
}


